﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WMDIOAPP
{
    public partial class Form1 : Form
    {
        //static int PinNum;
        public enum GPIO_BIT
        {
            PIN1 = 0x0001,
            PIN2 = 0x0002,
            PIN3 = 0x0004,
            PIN4 = 0x0008,
            PIN5 = 0x0010,
            PIN6 = 0x0020,
            PIN7 = 0x0040,
            PIN8 = 0x0080,
            PIN9 = 0x0100,
            PIN10 = 0x0200,
            PIN11 = 0x0400,
            PIN12 = 0x0800,
            PIN13 = 0x1000
        };

        public Form1()
        {
            InitializeComponent();
            WMDIO.WM_GpioOpen();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            WMDIO.WM_GpioClose();
            DItimer.Enabled = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DItimer.Interval = 1000;
            DItimer.Enabled = true;
        }

        private void DItimer_Tick(object sender, EventArgs e)
        {
            UInt16 DIDOSt;

            if (WMDIO.WM_GetDIData(out DIDOSt))
            {
                if ((DIDOSt & (ushort)GPIO_BIT.PIN1) == (ushort)GPIO_BIT.PIN1)
                {
                    DI01H.Checked = true;
                }
                else
                {
                    DI01L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN2) == (ushort)GPIO_BIT.PIN2)
                {
                    DI02H.Checked = true;
                }
                else
                {
                    DI02L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN3) == (ushort)GPIO_BIT.PIN3)
                {
                    DI03H.Checked = true;
                }
                else
                {
                    DI03L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN4) == (ushort)GPIO_BIT.PIN4)
                {
                    DI04H.Checked = true;
                }
                else
                {
                    DI04L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN5) == (ushort)GPIO_BIT.PIN5)
                {
                    DI05H.Checked = true;
                }
                else
                {
                    DI05L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN6) == (ushort)GPIO_BIT.PIN6)
                {
                    DI06H.Checked = true;
                }
                else
                {
                    DI06L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN7) == (ushort)GPIO_BIT.PIN7)
                {
                    DI07H.Checked = true;
                }
                else
                {
                    DI07L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN8) == (ushort)GPIO_BIT.PIN8)
                {
                    DI08H.Checked = true;
                }
                else
                {
                    DI08L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN9) == (ushort)GPIO_BIT.PIN9)
                {
                    DI09H.Checked = true;
                }
                else
                {
                    DI09L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN10) == (ushort)GPIO_BIT.PIN10)
                {
                    DI1_H.Checked = true;
                }
                else
                {
                    DI1_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN11) == (ushort)GPIO_BIT.PIN11)
                {
                    DI2_H.Checked = true;
                }
                else
                {
                    DI2_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN12) == (ushort)GPIO_BIT.PIN12)
                {
                    DI3_H.Checked = true;
                }
                else
                {
                    DI3_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN13) == (ushort)GPIO_BIT.PIN13)
                {
                    DI4_H.Checked = true;
                }
                else
                {
                    DI4_L.Checked = true;
                }
            }
        }

        private void SetSt_Click(object sender, EventArgs e)
        {
            UInt16 DIDOst = 0x000;

            if (DO01H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN1;
            }

            if (DO02H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN2;
            }

            if (DO03H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN3;
            }

            if (DO04H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN4;
            }

            if (DO05H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN5;
            }

            if (DO06H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN6;
            }

            if (DO07H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN7;
            }

            if (DO08H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN8;
            }

            if (DO09H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN9;
            }

            if (DO1_H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN10;
            }

            if (DO2_H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN11;
            }

            if (DO3_H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN12;
            }

            if (DO4_H.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN13;
            }

            WMDIO.WM_SetDOData(DIDOst);
        }

        private void GetSt_Click(object sender, EventArgs e)
        {
            UInt16 DIDOSt;

            if (WMDIO.WM_GetDOData(out DIDOSt))
            {
                if ((DIDOSt & (ushort)GPIO_BIT.PIN1) == (ushort)GPIO_BIT.PIN1)
                {
                    DO01H.Checked = true;
                }
                else
                {
                    DO01L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN2) == (ushort)GPIO_BIT.PIN2)
                {
                    DO02H.Checked = true;
                }
                else
                {
                    DO02L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN3) == (ushort)GPIO_BIT.PIN3)
                {
                    DO03H.Checked = true;
                }
                else
                {
                    DO03L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN4) == (ushort)GPIO_BIT.PIN4)
                {
                    DO04H.Checked = true;
                }
                else
                {
                    DO04L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN5) == (ushort)GPIO_BIT.PIN5)
                {
                    DO05H.Checked = true;
                }
                else
                {
                    DO05L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN6) == (ushort)GPIO_BIT.PIN6)
                {
                    DO06H.Checked = true;
                }
                else
                {
                    DO06L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN7) == (ushort)GPIO_BIT.PIN7)
                {
                    DO07H.Checked = true;
                }
                else
                {
                    DO07L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN8) == (ushort)GPIO_BIT.PIN8)
                {
                    DO08H.Checked = true;
                }
                else
                {
                    DO08L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN9) == (ushort)GPIO_BIT.PIN9)
                {
                    DO09H.Checked = true;
                }
                else
                {
                    DO09L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN10) == (ushort)GPIO_BIT.PIN10)
                {
                    DO1_H.Checked = true;
                }
                else
                {
                    DO1_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN11) == (ushort)GPIO_BIT.PIN11)
                {
                    DO2_H.Checked = true;
                }
                else
                {
                    DO2_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN12) == (ushort)GPIO_BIT.PIN12)
                {
                    DO3_H.Checked = true;
                }
                else
                {
                    DO3_L.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN13) == (ushort)GPIO_BIT.PIN13)
                {
                    DO4_H.Checked = true;
                }
                else
                {
                    DO4_L.Checked = true;
                }
            }
        }

        private void DI_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int i = -1;
            string name = string.Empty;
            string status = string.Empty;

            i = cb.Text.IndexOf("High");
            if (i >= 0)
            {
                status = "High";
                name = cb.Name.Substring(0, 4);
            }
            else
            {
                i = cb.Text.IndexOf("Low");
                if (i >= 0)
                {
                    status = "Low";
                    name = cb.Name.Substring(0, 4);
                }
            }

            foreach (Control ctrl in this.groupBox1.Controls)
            {
                if (cb.Checked)
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "H")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "L")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                }
                else
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "H")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "L")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                }
            }
        }

        private void DO_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int i = -1;
            string name = string.Empty;
            string status = string.Empty;

            i = cb.Text.IndexOf("High");
            if (i >= 0)
            {
                status = "High";
                name = cb.Name.Substring(0, 4);
            }
            else
            {
                i = cb.Text.IndexOf("Low");
                if (i >= 0)
                {
                    status = "Low";
                    name = cb.Name.Substring(0, 4);
                }
            }

            foreach (Control ctrl in this.groupBox2.Controls)
            {
                if (cb.Checked)
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "H")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "L")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                }
                else
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "H")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "L")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                }
            }
        }
    }
}